
Add LoadPath "./multi_thesis".

Require Import ssreflect ssrnat ssralg. 
Require Import Reals Fourier.
Require Import Rstruct vector.


Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Open Local Scope R_scope.


Section MetricSpace.

(*
Structure MetricSpace : Type := metricSpace
  {Base :> Type;
    distance : Base -> Base -> R;
    distance_sym : forall x y:Base, distance x y = distance y x;
    distance_refl : forall x y:Base, distance x y = 0 <-> x = y;
    distance_tri : forall x y z:Base, distance x y <= distance x z + distance z y}.

Lemma distance_pos: forall (X: MetricSpace) (x y:X), 0 <= distance x y.
Proof.
move=>X x y.
have H: distance x x = 0.
by apply/distance_refl.
apply Rmult_le_reg_l with 2; first by fourier.
ring_simplify; rewrite -H.
replace (2* distance x y) with (distance x y + distance y x);
[apply distance_tri|].
 rewrite distance_sym; ring.
Qed.
*)


Definition conv (X: Metric_Space) (Xn: nat -> X) l :=
forall eps:R, 0 < eps-> exists N: nat, 
  (forall n:nat, (N <= n)%nat -> dist (Xn n) l < eps).

Definition isCauchy (X: Metric_Space) (Xn : nat -> X) :=
forall eps:R, 0 < eps -> exists N : nat,
  (forall n m:nat, (N <= n)%nat -> (N <= m)%nat -> dist (Xn n) (Xn m) < eps).

Definition limit (X X':Metric_Space) (f: X -> X') (x0: X) (l: X') :=
  forall eps:R, 0 < eps  -> exists alp : R, 0 < alp  /\
      (forall x: X, R0< dist x x0 < alp -> dist (f x) l < eps).

Definition cont (X X':Metric_Space) (f: X -> X') (x0: X)  :=
  forall eps:R, 0 < eps -> exists alp : R, 0 < alp  /\
      (forall x: X, dist x x0 < alp -> dist (f x) (f x0) < eps).

Lemma echiv_lim_f:
forall (X X':Metric_Space) (f g: X -> X') x l,
(forall t, f t = g t) ->
(limit f x l <-> limit g x l).
Proof.
move => X X' f g x l H.
split; move => H1 eps He; elim (H1 eps He) =>a [Ha Hr] ;
exists a; split.
done.
by move => y Hy; rewrite -(H y); apply Hr.
done.
by move => y Hy; rewrite (H y) ; apply Hr.
Qed.
 
Lemma echiv_lim_f1:
forall (X X': Metric_Space) (f g: X ->X') x l,
(forall t, f t = g t) ->
(limit f x l -> limit g x l).
Proof.
move => X X' f g x l H  H2.
by rewrite -(@echiv_lim_f X X' f g x l H ).
Qed.

Lemma cond_eq_el :
  forall (X:Metric_Space) (x y: X), 
  (forall eps:R, R0 < eps -> dist x  y < eps) -> x = y.
Proof.
move =>X x y H.
have Hra: ~ R0 < dist x y.
rewrite /not => Hdist.
have Hco: dist x  y < (dist x y)*/2.
by apply H; fourier.
have Hco2: ~ dist x y < dist x y */2.
by fourier.
contradiction.
rewrite -(Rlimit.dist_refl).
by elim (Rlimit.dist_pos x y).
Qed.

End MetricSpace.


(*
Canonical Structure R_met := 
  Build_Metric_Space  R_dist_sym R_dist_refl R_dist_tri.

Canonical Structure Rp_met (p:pos_nat) := 
  metricSpace (@vector.dist_sym p) (@vector.dist_refl p ) (@vector.dist_tri p ).
*)
